export default class DefaultPreset {
    plugins: (typeof Poster | typeof Start | typeof Enter | typeof Loading | typeof PlayIcon | typeof FullScreen | typeof TimeIcon | typeof Volume | typeof RotateIcon | typeof PIPIcon | typeof DefinitionIcon | typeof PlaybackRateIcon | typeof CssFullScreen | typeof Error)[];
    ignores: any[];
    i18n: {
        LANG: string;
        TEXT: {
            ERROR_TYPES: {
                network: {
                    code: number;
                    msg: string;
                };
                mse: {
                    code: number;
                    msg: string;
                };
                parse: {
                    code: number;
                    msg: string;
                };
                format: {
                    code: number;
                    msg: string;
                };
                decoder: {
                    code: number;
                    msg: string;
                };
                runtime: {
                    code: number;
                    msg: string;
                };
                timeout: {
                    code: number;
                    msg: string;
                };
                other: {
                    code: number;
                    msg: string;
                };
            };
            HAVE_NOTHING: string;
            HAVE_METADATA: string;
            HAVE_CURRENT_DATA: string;
            HAVE_FUTURE_DATA: string;
            HAVE_ENOUGH_DATA: string;
            NETWORK_EMPTY: string;
            NETWORK_IDLE: string;
            NETWORK_LOADING: string;
            NETWORK_NO_SOURCE: string;
            MEDIA_ERR_ABORTED: string;
            MEDIA_ERR_NETWORK: string;
            MEDIA_ERR_DECODE: string;
            MEDIA_ERR_SRC_NOT_SUPPORTED: string;
            REPLAY: string;
            ERROR: string;
            PLAY_TIPS: string;
            PAUSE_TIPS: string;
            PLAYNEXT_TIPS: string;
            DOWNLOAD_TIPS: string;
            ROTATE_TIPS: string;
            RELOAD_TIPS: string;
            FULLSCREEN_TIPS: string;
            EXITFULLSCREEN_TIPS: string;
            CSSFULLSCREEN_TIPS: string;
            EXITCSSFULLSCREEN_TIPS: string;
            TEXTTRACK: string;
            PIP: string;
            SCREENSHOT: string;
            LIVE: string;
            OFF: string;
            OPEN: string;
            MINI_DRAG: string;
            MINISCREEN: string;
            REFRESH_TIPS: string;
            REFRESH: string;
            FORWARD: string;
            LIVE_TIP: string;
        };
    }[];
}
import Poster from "../plugins/poster";
import Start from "../plugins/start";
import Enter from "../plugins/enter";
import Loading from "../plugins/loading";
import PlayIcon from "../plugins/play";
import FullScreen from "../plugins/fullscreen";
import TimeIcon from "../plugins/time";
import Volume from "../plugins/volume";
import RotateIcon from "../plugins/rotate";
import PIPIcon from "../plugins/pip";
import DefinitionIcon from "../plugins/definition";
import PlaybackRateIcon from "../plugins/playbackRate";
import CssFullScreen from "../plugins/cssFullScreen";
import Error from "../plugins/error";
